## qmapshack 1.18.0

=== CMakeLists.txt ===
###############################################################################################
# CMake compatibility requirements
###############################################################################################
cmake_minimum_required(VERSION 3.20.0)

# Needed to properly handle extract translations strings when using the Ninja
# generator.
if (COMMAND CMAKE_POLICY)
    if (POLICY CMP0058)
        cmake_policy(SET CMP0058 NEW)
    endif()
endif()

if (COMMAND CMAKE_POLICY)
    if (POLICY CMP0048)
        cmake_policy(SET CMP0048 NEW)
    endif()
endif()


###############################################################################################
# Define project name and version tags
###############################################################################################
# this is not only the QMS version it will be the package version, too.
project(QMapShack VERSION 1.18.0 LANGUAGES CXX C)
set(CMAKE_CXX_STANDARD 11)

# FOR A RELEASE:
# remove "development" for a release
set(DEVELOPMENT_VERSION OFF)


###############################################################################################
# Define paths and include other modules
###############################################################################################
# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
if(WIN32)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules;${CMAKE_SOURCE_DIR}/msvc_64/cmake)
else(WIN32)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)
endif(WIN32)

# all binaries are collected in the ./bin directory
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)

include(DefineCMakeDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(CPackConfig.cmake)
include(ConfigureChecks.cmake)

###############################################################################################
# All boolean options
###############################################################################################

# Feature related
option(BUILD_QMAPSHACK      "Build QMapShack Binary"                                ON)
option(BUILD_QMAPTOOL       "Build QMapTool Binary including command line tools"    ON)

if(WIN32)
option(USE_QT6DBus          "Enable device detection via DBus"                      OFF)
else(WIN32)
option(USE_QT6DBus          "Enable device detection via DBus"                      ON)
endif(WIN32)

# Compiler related
option(BUILD_FOR_LOCAL_SYSTEM "Build for local system ONLY (resulting binary might not work on other systems!)" OFF)

###############################################################################################
# Translation options
###############################################################################################
option(UPDATE_TRANSLATIONS "Update translation files" ON)
option(UPDATE_TRANSLATIONS_PURGE_OBSOLETE "Remove obsolete translations" OFF)


###############################################################################################
# All OS and compiler specific tweaks
###############################################################################################
if (APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_INIT} -Wall -std=c++11 -stdlib=libc++")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -framework Foundation -framework DiskArbitration")
    SET(LINK_FLAGS "${LINK_FLAGS} -framework Foundation -framework DiskArbitration")

    if(NOT DEFINED QT_DEV_PATH)
        message(FATAL_ERROR "QT_DEV_PATH not set!!!")
    endif()
    # set(QT_DEV_PATH   ${QT_DEV_PATH} CACHE PATH "Path to directory containing Qt6 include and lib")
    message("QT_DEV_PATH = ${QT_DEV_PATH}")

    if(NOT DEFINED ROUTINO_DEV_PATH)
        message(FATAL_ERROR "ROUTINO_DEV_PATH not set!!!")
    endif(NOT DEFINED ROUTINO_DEV_PATH)
    # set(ROUTINO_DEV_PATH ${ROUTINO_DEV_PATH} CACHE PATH "Path to directory containing routino include and lib")
    message("ROUTINO_DEV_PATH = ${ROUTINO_DEV_PATH}")
    
    if(NOT DEFINED QuaZip-Qt6_DIR)
        message(FATAL_ERROR "QuaZip-Qt6_DIR not set!!!")
    endif(NOT DEFINED QuaZip-Qt6_DIR)    
    # set(QuaZip-Qt6_DIR ${QuaZip-Qt6_DIR} CACHE PATH "Path to directory containing quazip cmake config files")
    message("QuaZip-Qt6_DIR = ${QuaZip-Qt6_DIR}")

    if(NOT DEFINED PROJ_DEV_PATH)
        message(FATAL_ERROR "PROJ_DEV_PATH not set!!!")
    endif(NOT DEFINED PROJ_DEV_PATH)
    # set(PROJ_DEV_PATH ${PROJ_DEV_PATH} CACHE PATH "Path to directory containing PROJ include and lib")
    message("PROJ_DEV_PATH = ${PROJ_DEV_PATH}")

    if(NOT DEFINED GDAL_DEV_PATH)
        message(FATAL_ERROR "GDAL_DEV_PATH not set!!!")
    endif(NOT DEFINED GDAL_DEV_PATH)
    # set(GDAL_DEV_PATH ${GDAL_DEV_PATH} CACHE PATH "Path to directory containing GDAL include and lib")
    message("GDAL_DEV_PATH = ${GDAL_DEV_PATH}")
    # set(JPEG_DEV_PATH "C:\\JPEG" CACHE PATH "Path to directory containing JPEG include and lib, e.g. M:\\lib\\JPEG")

    set(CMAKE_PREFIX_PATH ${QT_DEV_PATH})
    message("CMAKE_PREFIX_PATH = ${CMAKE_PREFIX_PATH}")
endif(APPLE)

if(WIN32)
    set(QT_DEV_PATH   "C:\\Qt\\5.12.11\\msvc2017_64" CACHE PATH "Path to directory containing Qt6 include and lib, e.g. C:\\Qt\\5.12.10\\msvc2017_64")
    set(GDAL_DEV_PATH "C:\\GDAL" CACHE PATH "Path to directory containing GDAL include and lib, e.g. M:\\lib\\gdal")
    set(PROJ_DEV_PATH "C:\\PROJ8" CACHE PATH "Path to directory containing PROJ include and lib, e.g. M:\\lib\\PROJ8")
    set(ROUTINO_DEV_PATH "C:\\routino" CACHE PATH "Path to directory containing routino include and lib, e.g. M:\\lib\\routino")
    set(QuaZip-Qt6_DIR "C:\\quazip" CACHE PATH "Path to directory containing quazip cmake config files, e.g. M:\\lib2017\\QUAZIP_1\\lib\\cmake\\QuaZip-Qt5-1.1")
    set(JPEG_DEV_PATH "C:\\JPEG" CACHE PATH "Path to directory containing JPEG include and lib, e.g. M:\\lib\\JPEG")
    set(CMAKE_PREFIX_PATH ${QT_DEV_PATH})
    if(POLICY CMP0074)
        #policy for <PackageName>_ROOT variables - see https://cmake.org/cmake/help/latest/policy/CMP0074.html
        cmake_policy(SET CMP0074 NEW)
    endif()	
    set(ZLIB_ROOT "C:\\zlib" CACHE PATH "Path to directory containing ZLIB, e.g. M:\\lib2017\\zlib")
    set(ZLIB_LIBRARY "C:\\zlib\\lib\\zlibwapi.lib" CACHE FILEPATH "Path to directory containing ZLIB library, e.g. M:\\lib2017\\zlib\\lib\\zlibwapi.lib")
endif(WIN32)

if(MSVC)
    # Add link-time code generation to improve performance
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE    "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_compile_options(/MP)
endif(MSVC)

if(UNIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -lm")
    add_definitions(-Wall -Wpedantic -Wno-switch -Wno-strict-aliasing)

    # Use ASAN for development versions
    if(${DEVELOPMENT_VERSION})
        check_cxx_compiler_flag("-fsanitize=address" WITH_ASAN)
        if(NOT ${WITH_ASAN})
            message(FATAL_ERROR "Could not find ASAN! Please install ASAN if you want to compile development versions." )
        endif(NOT ${WITH_ASAN})
        message(STATUS "Using ASAN")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
    endif(${DEVELOPMENT_VERSION})
endif(UNIX)


###############################################################################################
# GCC specific compiler tweaks
###############################################################################################
if(BUILD_FOR_LOCAL_SYSTEM)
    cxx_local_system_optimization()
endif(BUILD_FOR_LOCAL_SYSTEM)

# try to figure out which compiler flags are supported (and add them)
cxx_add_flag_if_supported(-Wsuggest-override)
cxx_add_flag_if_supported(-Woverloaded-virtual)

###############################################################################################
# Find all required packages and setup internal variables
###############################################################################################
find_package(Qt6Core                REQUIRED)


if (Qt6Core_VERSION VERSION_LESS 6.8.0)
        message(FATAL_ERROR "Qt 6.8.0 or later is required.")
endif()


find_package(Qt6Widgets             REQUIRED)
find_package(Qt6Xml                 REQUIRED)
find_package(Qt6Sql                 REQUIRED)
find_package(Qt6LinguistTools       REQUIRED)
find_package(Qt6PrintSupport        REQUIRED)
find_package(Qt6UiTools             REQUIRED)
find_package(Qt6Network             REQUIRED)
find_package(Qt6WebEngineWidgets    REQUIRED)
find_package(Qt6Qml                 REQUIRED)
find_package(Qt6Help                REQUIRED)
find_package(GDAL                   REQUIRED)
find_package(PROJ                   REQUIRED)
find_package(JPEG                   REQUIRED)
find_package(ROUTINO                REQUIRED)
find_package(QuaZip-Qt6             REQUIRED)
find_package(ALGLIB                         ) # optional as we can use our local version

qt_standard_project_setup(
    I18N_TRANSLATED_LANGUAGES ca cs de es fr it nl ru
)

if(${PROJ_VERSION} VERSION_LESS 8.0.0)
    message( SEND_ERROR "You need at least PROJ 8.0.0 or newer.")
endif()

if(USE_QT6DBus)
    find_package(Qt6DBus REQUIRED)
    if(Qt6DBus_FOUND)
        add_definitions(-DHAVE_DBUS)
    endif(Qt6DBus_FOUND)
endif(USE_QT6DBus)

# Everything included. Let's finetune the mess a bit more

if(APPLE)
     find_library(DiskArbitration_LIBRARY DiskArbitration)
     find_library(Foundation_LIBRARY Foundation)
endif(APPLE)


if(NOT ALGLIB_FOUND AND BUILD_QMAPSHACK)
    set(ALGLIB_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/alglib/src)
    set(ALGLIB_LIBRARIES alg)
    add_subdirectory(3rdparty/alglib)
endif(NOT ALGLIB_FOUND AND BUILD_QMAPSHACK)

add_definitions(-DHELPPATH=${HTML_INSTALL_DIR})

###############################################################################################
# Create library from Garmin's FIT SDK
###############################################################################################
add_subdirectory(3rdparty/GarminFitSdk/)

###############################################################################################
# Create global config.h
###############################################################################################
if (APPLE)
  set(PROGNAME "QMapShack")
  set(CONFIGDIR "Library/Application Support/${PROGNAME}/")
else(APPLE)
  set(PROGNAME ${PROJECT_NAME})
  set(CONFIGDIR ".config/QLandkarte/")
endif(APPLE)

configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

###############################################################################################
# Now we are ready to compile all sub-projects
###############################################################################################
if(BUILD_QMAPSHACK)
add_subdirectory(src/qmapshack)
endif(BUILD_QMAPSHACK)

if(BUILD_QMAPTOOL)
add_subdirectory(src/qmaptool)
add_subdirectory(src/qmt_rgb2pct)
add_subdirectory(src/qmt_map2jnx)
endif(BUILD_QMAPTOOL)

###############################################################################################
# Copy a few more files need by the install/unistall target
###############################################################################################
if (UNIX AND NOT WIN32 AND NOT APPLE)
if(BUILD_QMAPSHACK)
    install( FILES        qmapshack.desktop                 DESTINATION     ${XDG_APPS_DIR} )
    install( FILES        src/icons/48x48/QMapShack.png     DESTINATION     ${DATA_INSTALL_PREFIX}/pixmaps )
    install( DIRECTORY    src/icons/qmapshack/hicolor       DESTINATION     ${ICON_INSTALL_DIR} )
    install( FILES        qmapshack.1                       DESTINATION     ${MAN_INSTALL_DIR}/man1  )

=== src/qmapshack/CMakeLists.txt ===
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


###############################################################################################
# Setup application name and defines
###############################################################################################

STRING(TOLOWER ${PROJECT_NAME} APPLICATION_NAME)

# and other funny defines -> maybe config.h is a better place for that
add_definitions(-DROUTINO_XML_PATH=${ROUTINO_XML_PATH})

###############################################################################################
# All source files needed to compile
###############################################################################################

set( SRCS
    CAbout.cpp
    CMainWindow.cpp
    CSingleInstanceProxy.cpp
    canvas/CCanvas.cpp
    canvas/CCanvasSetup.cpp
    canvas/CCanvasSelect.cpp
    canvas/IDrawContext.cpp
    canvas/IDrawObject.cpp
    dem/CDemDraw.cpp
    dem/CDemItem.cpp
    dem/CDemList.cpp
    dem/CDemPathSetup.cpp
    dem/CDemPropSetup.cpp
    dem/CDemVRT.cpp
    dem/CDemWCS.cpp
    dem/IDem.cpp
    dem/IDemProp.cpp
    device/CDeviceGarmin.cpp
    device/CDeviceGarminArchive.cpp
    device/CDeviceTwoNav.cpp
    device/IDevice.cpp
    device/IDeviceWatcher.cpp
    gis/CGisDatabase.cpp
    gis/CGisDraw.cpp
    gis/CGisItemRate.cpp
    gis/CGisListDB.cpp
    gis/CGisListWks.cpp
    gis/CGisWorkspace.cpp
    gis/CSelDevices.cpp
    gis/IGisItem.cpp
    gis/IGisLine.cpp
    gis/db/CDBFolderGroup.cpp
    gis/db/CDBFolderLostFound.cpp
    gis/db/CDBFolderMysql.cpp
    gis/db/CDBFolderOther.cpp
    gis/db/CDBFolderProject.cpp
    gis/db/CDBFolderSqlite.cpp
    gis/db/CDBItem.cpp
    gis/db/CDBProject.cpp
    gis/db/CExportDatabase.cpp
    gis/db/CExportDatabaseThread.cpp
    gis/db/CLostFoundProject.cpp
    gis/db/CResolveDatabaseConflict.cpp
    gis/db/CSearchDatabase.cpp
    gis/db/CSelectDBFolder.cpp
    gis/db/CSelectSaveAction.cpp
    gis/db/CSetupDatabase.cpp
    gis/db/CSetupFolder.cpp
    gis/db/CSetupWorkspace.cpp
    gis/db/IDB.cpp
    gis/db/IDBFolder.cpp
    gis/db/IDBFolderSql.cpp
    gis/db/IDBMysql.cpp
    gis/db/IDBSqlite.cpp
    gis/fit2/CFit2Project.cpp
    gis/gpx/CGpxProject.cpp
    gis/gpx/serialization.cpp
    gis/ovl/CDetailsOvlArea.cpp
    gis/ovl/CGisItemOvlArea.cpp
    gis/ovl/CScrOptOvlArea.cpp
    gis/prj/CDetailsPrj.cpp
    gis/prj/IGisProject.cpp
    gis/qlb/CQlbProject.cpp
    gis/qms/CQmsProject.cpp
    gis/qms/serialization.cpp
    gis/rte/CCreateRouteFromWpt.cpp
    gis/rte/CDetailsRte.cpp
    gis/rte/CGisItemRte.cpp
    gis/rte/CScrOptRte.cpp
    gis/rte/router/CRouterBRouter.cpp
    gis/rte/router/CRouterOptimization.cpp
    gis/rte/router/CRouterRoutino.cpp
    gis/rte/router/CRouterSetup.cpp
    gis/rte/router/IRouter.cpp
    gis/rte/router/brouter/CRouterBRouterDownloadPage.cpp
    gis/rte/router/brouter/CRouterBRouterInfo.cpp
    gis/rte/router/brouter/CRouterBRouterLocal.cpp
    gis/rte/router/brouter/CRouterBRouterSetup.cpp
    gis/rte/router/brouter/CRouterBRouterSetupPage.cpp
    gis/rte/router/brouter/CRouterBRouterSetupWizard.cpp
    gis/rte/router/brouter/CRouterBRouterTilesPage.cpp
    gis/rte/router/brouter/CRouterBRouterTilesSelect.cpp
    gis/rte/router/brouter/CRouterBRouterTilesSelectArea.cpp
    gis/rte/router/brouter/CRouterBRouterToolShell.cpp
    gis/rte/router/routino/CRouterRoutinoPathSetup.cpp
    gis/search/CGeoSearch.cpp
    gis/search/CGeoSearchConfig.cpp
    gis/search/CGeoSearchConfigDialog.cpp
    gis/search/CProjectFilterItem.cpp
    gis/search/CSearchExplanationDialog.cpp
    gis/search/CSearchLineEdit.cpp
    gis/search/CGeoSearchWeb.cpp
    gis/search/CGeoSearchWebConfigDialog.cpp
    gis/slf/CSlfProject.cpp
    gis/slf/CSlfReader.cpp
    gis/summary/CGisSummary.cpp
    gis/summary/CGisSummaryDropZone.cpp
    gis/summary/CGisSummarySetup.cpp
    gis/suunto/CLogProject.cpp
    gis/suunto/CSmlProject.cpp
    gis/suunto/ISuuntoProject.cpp
    gis/tcx/CTcxProject.cpp
    gis/tcx/serialization.cpp
    gis/tnv/CTwoNavProject.cpp
    gis/tnv/serialization.cpp
    gis/trk/CActivityTrk.cpp
    gis/trk/CCombineTrk.cpp
    gis/trk/CCutTrk.cpp
    gis/trk/CDetailsTrk.cpp
    gis/trk/CEnergyCycling.cpp
    gis/trk/CEnergyCyclingDialog.cpp
    gis/trk/CGisItemTrk.cpp
    gis/trk/CInvalidTrk.cpp
    gis/trk/CKnownExtension.cpp
    gis/trk/CListTrkPts.cpp
    gis/trk/CPropertyTrk.cpp
    gis/trk/CScrOptTrk.cpp
    gis/trk/CSelectActivityColor.cpp
    gis/trk/CTableTrk.cpp
    gis/trk/CTableTrkInfo.cpp
    gis/trk/CTrkToRteDialog.cpp
    gis/trk/CTrackData.cpp
    gis/trk/filter/CFilterChangeStartPoint.cpp
    gis/trk/filter/CFilterDelete.cpp
    gis/trk/filter/CFilterDeleteExtension.cpp
    gis/trk/filter/CFilterDouglasPeuker.cpp
    gis/trk/filter/CFilterInterpolateElevation.cpp
    gis/trk/filter/CFilterInvalid.cpp
    gis/trk/filter/CFilterLoopsCut.cpp
    gis/trk/filter/CFilterMedian.cpp
    gis/trk/filter/CFilterNewDate.cpp
    gis/trk/filter/CFilterObscureDate.cpp
    gis/trk/filter/CFilterOffsetElevation.cpp
    gis/trk/filter/CFilterReplaceElevation.cpp
    gis/trk/filter/CFilterReset.cpp
    gis/trk/filter/CFilterSpeed.cpp
    gis/trk/filter/CFilterSpeedConst.cpp
    gis/trk/filter/CFilterSpeedCycle.cpp
    gis/trk/filter/CFilterSpeedHike.cpp
    gis/trk/filter/CFilterSplitSegment.cpp
    gis/trk/filter/CFilterSplitTrack.cpp
    gis/trk/filter/CFilterSubPt2Pt.cpp
    gis/trk/filter/CFilterTerrainSlope.cpp
    gis/trk/filter/CFilterZeroSpeedDriftCleaner.cpp
    gis/trk/filter/filter.cpp
    gis/wpt/CDetailsGeoCache.cpp
    gis/wpt/CDetailsWpt.cpp
    gis/wpt/CGisItemWpt.cpp
    gis/wpt/CProjWpt.cpp
    gis/wpt/CScrOptWpt.cpp
    gis/wpt/CScrOptWptRadius.cpp
    gis/wpt/CSetupIconAndName.cpp
    grid/CGrid.cpp
    grid/CGridSetup.cpp
    grid/CProjWizard.cpp
    grid/mitab.cpp
    helpers/CDraw.cpp
    helpers/CElevationDialog.cpp
    gis/search/CSearch.cpp
    helpers/CInputDialog.cpp
    helpers/CLimit.cpp
    helpers/CLinksDialog.cpp
    helpers/CPhotoViewer.cpp
    helpers/CPositionDialog.cpp
    helpers/CProgressDialog.cpp
    helpers/CSelectCopyAction.cpp
    helpers/CSelectProjectDialog.cpp
    helpers/CTimeDialog.cpp
    helpers/CToolBarConfig.cpp
    helpers/CToolBarSetupDialog.cpp
    helpers/CValue.cpp
    helpers/CWptIconDialog.cpp
    helpers/CWptIconManager.cpp
    main.cpp
    map/CMapDraw.cpp
    map/CMapGEMF.cpp
    map/CMapIMG.cpp
    map/CMapItem.cpp
    map/CMapJNX.cpp
    map/CMapList.cpp
    map/CMapMAP.cpp
    map/CMapPathSetup.cpp
    map/CMapPropSetup.cpp
    map/CMapRMAP.cpp
    map/CMapTMS.cpp
    map/CMapVRT.cpp
    map/CMapWMTS.cpp
    map/IMap.cpp
    map/IMapOnline.cpp
    map/IMapProp.cpp
    map/cache/CDiskCache.cpp
    map/garmin/CGarminPoint.cpp
    map/garmin/CGarminPolygon.cpp
    map/garmin/CGarminStrTbl6.cpp
    map/garmin/CGarminStrTbl8.cpp
    map/garmin/CGarminStrTblUtf8.cpp
    map/garmin/CGarminTyp.cpp
    map/garmin/IGarminStrTbl.cpp
    map/mapsforge/types.cpp
    misc.h
    mouse/CMouseAdapter.cpp
    mouse/CMouseDummy.cpp
    mouse/CMouseEditArea.cpp
    mouse/CMouseEditRte.cpp
    mouse/CMouseEditTrk.cpp
    mouse/CMouseMoveWpt.cpp
    mouse/CMouseNormal.cpp
    mouse/CMousePrint.cpp
    mouse/CMouseRadiusWpt.cpp
    mouse/CMouseRangeTrk.cpp
    mouse/CMouseRuler.cpp
    mouse/CMouseSelect.cpp
    mouse/CMouseWptBubble.cpp
    mouse/CScrOptPrint.cpp
    mouse/range/CActionSelect.cpp
    mouse/range/CRangeToolSetup.cpp
    mouse/range/CScrOptRangeTool.cpp
    mouse/range/CScrOptRangeTrk.cpp
    mouse/CScrOptRuler.cpp
    mouse/CScrOptSelect.cpp
    mouse/CScrOptSemaphoreLocker.cpp
    mouse/CScrOptUnclutter.cpp
    mouse/IMouse.cpp
    mouse/IMouseSelect.cpp
    mouse/IScrOpt.cpp
    mouse/line/CLineOpAddPoint.cpp
    mouse/line/CLineOpDeletePoint.cpp
    mouse/line/CLineOpMovePoint.cpp
    mouse/line/CLineOpSelectRange.cpp
    mouse/line/CScrOptEditLine.cpp
    mouse/line/CScrOptRangeLine.cpp
    mouse/line/ILineOp.cpp
    mouse/line/IMouseEditLine.cpp
    plot/CPlot.cpp
    plot/CPlotAxis.cpp
    plot/CPlotAxisTime.cpp
    plot/CPlotData.cpp
    plot/CPlotProfile.cpp
    plot/CPlotTrack.cpp
    plot/IPlot.cpp
    plot/ITrack.cpp
    poi/CPoiCategory.cpp
    poi/CPoiDraw.cpp
    poi/CPoiFileItem.cpp
    poi/CPoiFilePOI.cpp
    poi/CPoiFilePOI_TagMap.cpp
    poi/CPoiIconCategory.cpp
    poi/CPoiItemPOI.cpp
    poi/CPoiList.cpp
    poi/CPoiPathSetup.cpp
    poi/CPoiPropSetup.cpp
    poi/IPoiFile.cpp
    poi/IPoiProp.cpp
    print/CPrintDialog.cpp
    print/CScreenshotDialog.cpp
    qlgt/CQlb.cpp
    qlgt/CQlgtDb.cpp
    qlgt/CQlgtDiary.cpp
    qlgt/CQlgtFolder.cpp
    qlgt/CQlgtRoute.cpp
    qlgt/CQlgtTrack.cpp
    qlgt/CQlgtWpt.cpp
    qlgt/CQmsDb.cpp
    qlgt/IItem.cpp
    qlgt/IQlgtOverlay.cpp
    qlgt/converter.cpp
    realtime/CRtDraw.cpp
    realtime/CRtSelectSource.cpp
    realtime/CRtWorkspace.cpp
    realtime/IRtInfo.cpp
    realtime/IRtRecord.cpp
    realtime/IRtSource.cpp
    realtime/gpstether/CRtGpsTether.cpp
    realtime/gpstether/CRtGpsTetherInfo.cpp
    realtime/gpstether/CRtGpsTetherRecord.cpp
    realtime/ais/CRtAis.cpp
    realtime/ais/CRtAisInfo.cpp
    realtime/ais/CRtAisRecord.cpp
    realtime/opensky/CRtOpenSky.cpp
    realtime/opensky/CRtOpenSkyInfo.cpp
    realtime/opensky/CRtOpenSkyRecord.cpp
    setup/CAppSetupLinux.cpp
    setup/CAppSetupMac.cpp
    setup/CAppSetupWin.cpp
    setup/CCommandProcessor.cpp
    setup/CLogHandler.cpp
    setup/IAppSetup.cpp
    tool/CImportDatabase.cpp
    tool/CMapVrtBuilder.cpp
    tool/CRoutinoDatabaseBuilder.cpp
    tool/IToolShell.cpp
    units/CCoordFormatSetup.cpp
    units/CTimeZoneSetup.cpp
    units/CUnitImperial.cpp
    units/CUnitMetric.cpp
    units/CUnitNautic.cpp
    units/CUnitAviation.cpp
    units/CUnitsSetup.cpp
    units/IUnit.cpp
    widgets/CColorLegend.cpp
    widgets/CDateTimeEditor.cpp
    widgets/CDoubleSpinBox.cpp
    widgets/CFadingIcon.cpp
    widgets/CHistoryListWidget.cpp
    widgets/CLineEdit.cpp
    widgets/CPhotoAlbum.cpp
    widgets/CSelectDoubleListWidget.cpp
    widgets/CScaleLabel.cpp
    widgets/CTemplateWidget.cpp
    widgets/CTextEdit.cpp
    widgets/CTextEditWidget.cpp
    widgets/CTextEditWidgetSelMenu.cpp
    widgets/CTinySpinBox.cpp
    ../common/help/CHelp.cpp
    ../common/help/CHelpBrowser.cpp
    ../common/help/CHelpIndex.cpp
    ../common/help/CHelpSearch.cpp
    ../common/gis/GeoMath.cpp
    ../common/gis/proj_x.cpp
)


if(Qt6DBus_FOUND)
set( SRCS
    ${SRCS}
    device/IDeviceAccess.cpp
    device/CDeviceWatcherLinux.cpp
    device/CDeviceAccessKMtp.cpp
    device/CDeviceAccessGvfsMtp.cpp
    device/CDeviceGarminMtp.cpp
    device/CDeviceGarminArchiveMtp.cpp
    device/CDeviceGenericMtp.cpp
    device/dbus/org.kde.kmtp.Daemon.cpp
    device/dbus/org.kde.kmtp.Device.cpp
    device/dbus/org.kde.kmtp.Storage.cpp
    device/dbus/org.gtk.vfs.MTPVolumeMonitor.cpp
    device/dbus/org.gtk.vfs.MountTracker.cpp
    device/dbus/org.gtk.vfs.Mount.cpp
    device/dbus/metatypes.cpp
)
endif(Qt6DBus_FOUND)


if (APPLE)
set( SRCS
    ${SRCS}
    device/CDeviceWatcherMac.cpp
)
endif(APPLE)

if(WIN32)
set( SRCS
    ${SRCS}
    device/CDeviceWatcherWindows.cpp
)
endif(WIN32)


set( HDRS
    CAbout.h
    CMainWindow.h
    CSingleInstanceProxy.h
    contributors.h
    canvas/CCanvas.h
    canvas/CCanvasSetup.h
    canvas/CCanvasSelect.h
    canvas/IDrawContext.h
    canvas/IDrawObject.h
    dem/CDemDraw.h
    dem/CDemItem.h
    dem/CDemList.h
    dem/CDemPathSetup.h
    dem/CDemPropSetup.h
    dem/CDemVRT.h
    dem/CDemWCS.h
    dem/IDem.h
    dem/IDemProp.h
    device/CDeviceGarmin.h
    device/CDeviceGarminArchive.h
    device/CDeviceTwoNav.h
    device/IDevice.h
    device/IDeviceWatcher.h
    gis/CGisDatabase.h
    gis/CGisDraw.h
    gis/CGisItemRate.h
    gis/CGisListDB.h
    gis/CGisListWks.h
    gis/CGisWorkspace.h
    gis/CSelDevices.h
    gis/IGisItem.h
    gis/IGisLine.h
    gis/db/CDBFolderGroup.h

=== debian/changelog ===
qmapshack (1.18.0-1) unstable; urgency=medium

  * Use -DUPDATE_TRANSLATIONS=OFF to fix building twice.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 10 Aug 2025 10:02:43 +0200

qmapshack (1.18.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Replace pkg-config build dependency with pkgconf.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update copyright file.
  * Update (build) dependencies for Qt6.
  * Drop obsolete quazip.patch.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 04 Jul 2025 17:08:26 +0200

=== debian/control ===
Source: qmapshack
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Jaromír Mikeš <mira.mikes@seznam.cz>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libalglib-dev,
               libgdal-dev (>= 1.10.1-0~),
               libproj-dev,
               libroutino-dev (>= 3.1),
               libquazip1-qt6-dev,
               pkgconf,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               qt6-webengine-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/qmapshack
Vcs-Git: https://salsa.debian.org/debian-gis-team/qmapshack.git
Homepage: https://github.com/Maproom/qmapshack/wiki
Rules-Requires-Root: no

Package: qmapshack
Architecture: any
Depends: libqt6sql6-sqlite,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: gdal-bin,
            routino
Suggests: gpsd
Description: GPS mapping (GeoTiff and vector) and GPSr management
 This package provides a versatile tool for GPS maps in GeoTiff format as
 well as Garmin's img vector map format.
 You can also view and edit your GPX tracks.
 QMapShack is the successor of QLandkarteGT.
 .
 Main features:
  - Use of several workspaces.
  - Use several maps on a workspace.
  - Handle data project-oriented.

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/,\
filenamemangle=s/(?:.*?)?(?:rel|v|V|qmapshack)?[\-\_]?(?:%20)?(\d+\.\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/qmapshack-$1.$2/ \
https://github.com/Maproom/qmapshack/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|V|qmapshack)?[\-\_]?(?:%20)?(\d+\.\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
